<script setup lang="ts">
import { onMounted, ref } from 'vue'

import { useUserStore } from '@/stores/user'
import { useBranchStore } from '@/stores/branch'
import { useMaterialStore } from '@/stores/material'
import AddinvoiceAllDialogVue from '@/views/invoice/AddInvoiceAllDialog.vue'
import deleteinvoiceDialogVue from '@/views/invoice/deleteDialog.vue'
import AddinvoiceSomeDialogVue from '@/views/invoice/AddInvoiceSomeDialog.vue'
import { useInvoiceStore } from '@/stores/invoice'
import type { Invoice } from '@/types/Invoice/Invoice'
import { useInvoiceDetailStore } from '@/stores/invoiceDetail'

const invoiceStore = useInvoiceStore()
const invoiceDetailStore = useInvoiceDetailStore()
const userStore = useUserStore()
const branchStore = useBranchStore()
const materialStore = useMaterialStore()

const invoiceheaders = [
  {
    title: 'รหัสสต็อก',
    key: 'id',
    value: 'id',
    width: '250px'
  },
  {
    title: 'สถานที่ซื้อ',
    key: 'place',
    value: 'place',
    width: '200px'
  },
  {
    title: 'ผู้เช็ค',
    key: 'user id',
    value: 'user id',
    width: '150px'
  },
  {
    title: 'สาขา',
    key: 'branch id',
    value: 'branch id',
    width: '100px'
  },
  {
    title: 'ราคา',
    key: 'price',
    value: 'price',
    width: '100px'
  }
]

const invoiceDetailsheaders = [
  {
    title: 'รหัสของรายละเอียดในสต็อก',
    key: 'id',
    value: 'id',
    width: '500px'
  },
  {
    title: 'ชื่อวัตถุดิบ',
    key: 'material id',
    value: 'material id',
    width: '200px'
  },
  {
    title: 'ปริมาณ',
    key: 'amount',
    value: 'amount',
    width: '50px'
  },
  {
    title: 'หน่วย',
    key: 'unit',
    value: 'unit',
    width: '100px'
  },
  {
    title: 'ราคา',
    key: 'price',
    value: 'price',
    width: '100px'
  }
]

const editedInvoice = ref<Invoice>()
const refByInvoiceId = ref<number>()

const send = (item: Invoice) => {
  console.log('invoices: ', invoiceStore.invoices)
  editedInvoice.value = JSON.parse(JSON.stringify(item))
  if (editedInvoice.value) {
    refByInvoiceId.value = editedInvoice.value.INV_ID
    getdetailByInvoiceId(refByInvoiceId.value)
    console.log('details: ', invoiceDetailStore.invoiceDetails)
  }
}

function getdetailByInvoiceId(InvoiceId: number) {
  invoiceDetailStore.getInvoiceDetailsByInvoiceId(InvoiceId)
}

function addDialog(add: string) {
  console.log('add', add)
  if (add === 'ADD invoice BY All MATERIAL') invoiceStore.addAllDialog = true
  else {
    invoiceStore.addSomeDialog = true
  }
}

onMounted(() => {
  invoiceStore.getInvoices()
  userStore.getUsers()
  branchStore.getBranches()
  materialStore.getMaterials()
  invoiceDetailStore.clearAddAllMat()
  invoiceDetailStore.addAllMat()
})

const items = ['ADD invoice BY All MATERIAL', 'ADD invoice BY SOME MATERIAL']
function printPDF() {
  const path = 'public/pdf/checkinvoicebill/checkinvoicebill.pdf'
  // เปิด PDF ในหน้าต่างใหม่
  window.open(path)
}
</script>

<template>
  <v-sheet>
    <v-row>
      <!-- First Table -->
      <v-col cols="5">
        <v-card>
          <v-toolbar flat color="#AB9283">
            <v-toolbar-title> Invoices </v-toolbar-title>

            <v-menu>
              <template v-slot:activator="{ props }">
                <v-btn
                  style="background-color: #ffcb5e; color: white; margin: 10px; color: black"
                  @click="printPDF()"
                >
                  PRINT BILL
                </v-btn>
                <v-btn
                  size="40px"
                  v-bind="props"
                  prepend-icon="mdi-plus-thick"
                  class="mr-5"
                  style="background-color: #ffcb5e; color: black"
                ></v-btn>
              </template>
              <v-list>
                <v-list-item v-for="(item, index) in items" :key="index" :value="index">
                  <v-list-item-title
                    @click="
                      addDialog(item),
                        invoiceDetailStore.clearAddAllMat(),
                        invoiceDetailStore.addAllMat()
                    "
                    >{{ item }}</v-list-item-title
                  >
                </v-list-item>
              </v-list>
            </v-menu>
          </v-toolbar>
          <v-data-table
            :items="invoiceStore.invoices"
            :headers="invoiceheaders"
            class="elevation-1 custom-table"
            fixed-header
            height="350px"
          >
            <template v-slot:item="props">
              <tr>
                <td @click="send(props.item)">{{ props.item.INV_ID }}</td>
                <td @click="send(props.item)">{{ props.item.INV_PLACE }}</td>
                <td @click="send(props.item)">
                  {{ invoiceStore.getUserName(props.item.INV_USER) }}
                </td>
                <td @click="send(props.item)">
                  {{ invoiceStore.getBranchName(props.item.INV_BRANCH) }}
                </td>
                <td @click="send(props.item)">
                  {{ props.item.INV_PRICE }}
                </td>
              </tr>
            </template>
          </v-data-table>
        </v-card>
      </v-col>

      <!-- Second Table -->
      <v-col cols="7">
        <v-card>
          <v-toolbar flat color="#AB9283">
            <v-toolbar-title> Invoice Details </v-toolbar-title>
            <v-spacer></v-spacer>
          </v-toolbar>
          <v-data-table
            :items="invoiceDetailStore.invoiceDetails"
            :headers="invoiceDetailsheaders"
            class="elevation-1 custom-table"
            fixed-header
            height="350px"
          >
            <template v-slot:item="props">
              <tr>
                <td>{{ props.item.IND_ID }}</td>
                <td>{{ invoiceDetailStore.getMaterialName(props.item.IND_MATERIAL) }}</td>
                <td>{{ props.item.IND_AMOUT }}</td>
                <td>{{ invoiceDetailStore.getMaterialType(props.item.IND_MATERIAL) }}</td>
                <td>{{ props.item.IND_PRICE }}</td>
              </tr>
            </template>
          </v-data-table>
        </v-card>
      </v-col>
    </v-row>
  </v-sheet>

  <AddinvoiceAllDialogVue></AddinvoiceAllDialogVue>
  <AddinvoiceSomeDialogVue></AddinvoiceSomeDialogVue>
  <deleteinvoiceDialogVue></deleteinvoiceDialogVue>
</template>

<style scoped>
.v-sheet {
  background-color: #fff5e8;
}

.v-toolbar {
  border-top-left-radius: 15px;
  border-top-right-radius: 15px;
  text-decoration: none;
  background-color: #ab9283;
}

.v-toolbar-title {
  font-weight: bold;
  font-size: 24px;
  color: white;
}

.v-table {
  border-bottom-left-radius: 15px;
  border-bottom-right-radius: 15px;
  text-decoration: none;
  background-color: #fff5e8;
}

.v-btn {
  border-radius: 30px;
  padding: 8px 16px;
}

.custom-header {
  background-color: #ffcb5e;
}
</style>
